;         

;        PIC12F629
;      
;  "0" -  
;  "1" -   -    
;  "2" -   -    

;      ,    
;        :
;  -     -      "1",   
;  -   ,     "0" 
;  - ,       
;  -      

;     ,   
;  (     "0"),        "2"
;            (TIME)

	list	P=PIC12F629		
 
#include <P12F629.INC>

 
;  
OZU1       	     	equ    	21h ;     1
PMOD2			 	equ    	22h ;     MOD2 (# 0) - 
TIME			 	equ    	23h ;  
BUF_TIME		 	equ    	24h ;   
OZU2			 	equ    	25h ;    2

; :

;7 	-GP0-    
;6 	-GP1-    1 ( )
;5 	-GP2-     2 (   )
;4 	-GP3-  ,   
;3 	-GP4-  
;2 	-GP5-  
;1      -VDD - +5V
;8      -VSS - GND

;           PIC-
		org 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;		      

	BCF STATUS,RP0;  0
	CLRF GPIO
	MOVLW b'00000111'
	MOVWF CMCON;     
	BSF STATUS,RP0 ;  1
	MOVLW b'00001110'
	MOVWF TRISIO;tris GPIO ; 1-3   GPIO     ,    
								;  3    

	BCF OPTION_REG,7 ;    
	MOVLW b'00000110';    GP1  GP2
	MOVWF WPU;
	BCF STATUS,RP0;  0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    
		CLRF  TIME
		CLRF PMOD2


;     
ST:
	CLRWDT
	

	
	BTFSS   GPIO,1
	GOTO MOD1 ;    "1" - 
	BTFSS   GPIO,2
	GOTO MOD2 ;    "2" - 
	GOTO MOD0 ;    "0" - 
		
	
	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


MOD0:      ;  
			BCF   GPIO,0 ;  
			MOVLW   b'10000000';     W.
		BTFSC   PMOD2,0 ;	,          
		MOVWF  TIME  ; .        W.
		CLRF PMOD2 ;     			
 	BTFSC   TIME,7
	GOTO   ST ;          (    128 )
	CALL  DELAY10T
	INCF     TIME,1
	GOTO   ST		
				GOTO  ST
;--------------------				
				
MOD1:      ;      
			BSF   GPIO,0 ;  
		CLRF PMOD2 ;     			
			CLRF   TIME ;   
			CALL  DELAY10T
				GOTO  ST
;--------------------------------------				
MOD2:      ;   
;;;		MOVLW  .15;;;;;;;;;
;;;		MOVWF  TIME
			BSF   GPIO,0 ;  
		BSF  PMOD2,0 ;        			
	CALL  DELAY4T
			BCF   GPIO,0 ;  	
; ,         
;  TIME       5
		MOVLW  .5
		SUBWF   TIME,0
		BTFSS  STATUS,C		
		GOTO  M1

	
; ,        
			MOVLW   b'10000000';     W.		
			SUBWF   TIME,0
		BTFSS  STATUS,C		
		GOTO M
		
M1:			MOVLW  .5		
		MOVWF  TIME		
					
M:			MOVF   TIME,0
			MOVWF   BUF_TIME
L2:			DECFSZ    BUF_TIME,1

			GOTO      L1      ;       
			GOTO         MOD2    ;    
			
L1:    ;   
			CALL  DELAY10T
			BTFSC   GPIO,2
			GOTO  ST ;    
			GOTO   L2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     ,    0,1 
TAKT:
	CLRWDT
	MOVLW	.200; 
           	MOVWF OZU2	
TAKT_0:	MOVLW	.189; 
           	MOVWF OZU1
TAKT_1:  DECFSZ OZU1,1
	 GOTO TAKT_1
 	  DECFSZ OZU2,1
	 GOTO TAKT_0	 
               RETURN


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   4 , ..  0,4 
DELAY4T:
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   10 , ..  1.0 
DELAY10T:
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT
	CALL TAKT	
	CALL TAKT
	CALL TAKT	
	RETURN	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
			ORG 0X00002007   ;   :   ,    
			DW  0X3F0C



	END
